/*
 * Copyright (c) 1997 Pietro Venanzangeli - All Rights Reserved.
 */

/**
 * Realizza un piccolo server interrogabile tramite la porta 23.
 * @author  Pietro Venanzangeli.
 * @version 1.0, 14-Nov-1997
 */



import java.io.*;
import java.util.*;
import GetTelnetLine;
import java.lang.*;
import DynaMode;
//import DIR;
//import ListOfFile;
//import SystemInformation;
import User;

public class ExecCommand {

  /** input buffeer */
  protected BufferedReader InBuff;
  /** output buffer */
  protected PrintStream    OutBuff;
  /** contiene la forma del prompt */
  protected String         Prompt;
  /** contiene tutti i dati dell' utente */
  protected User           crUser;
  /** indica se l'utente puo' utilizzare i comandi personalizzati */
  protected boolean UsePersonalCommand;

  /** 
   * Costruttore
   * @param crUser contiene tutte le informazioni dell' utente
   * @param Prompt e' il modello che si utilizzera' nel telnet
   */

  ExecCommand(User crUser,String Prompt) {
    this.crUser      = crUser;
    this.Prompt      = Prompt;
    this.InBuff      = crUser.GetInBuff();
    this.OutBuff     = crUser.GetOutBuff();
    if ( (crUser.GetCommand()) == null  || (crUser.GetCommand()).size()==0)
      UsePersonalCommand = false;
    else UsePersonalCommand = true;
    AutoGetExecute();
  }

  /** 
   * Prende i dati ed ed esegue il comando
   */
  public void AutoGetExecute(){
    GetTelnetLine tlLine = new GetTelnetLine(InBuff,OutBuff);
    OutBuff.print(Prompt);
    try {

      while (true) {
        String cm = tlLine.GetLine();
        if (cm != null ) {
          if (!Execute(cm))break;
          OutBuff.print(Prompt);
        }
      }
    }
    catch (TException e) {
      System.out.println(e.getMessage());
    }
  }

  /**
   * elabora i dati, prende la stringa di comando e cerca tra i comandi standart e gli altri 
   * @return : torna true se non e' stato richieta la chiusura altrimenti false 
   */
  public boolean Execute(String Command) {

    System.out.println(" USER [ " + crUser.GetUserID() +" - " + crUser.GetIpAddress() + " ] Comando : " + Command); // visualizza tutti i comandi richiesti...
    String crCommand = Filter(Command);
    if (crCommand.equalsIgnoreCase("EXIT")) {
      return false;
    }
    else if (crCommand.equalsIgnoreCase("QUIT")) {
      return false;
    }
    else if (crCommand.equalsIgnoreCase("BYE")) {
      return false;
    }
    else if (crCommand.equalsIgnoreCase("ABOUT")) {
      OutBuff.print("MokaServer\r\n" +  "MokaServer manager\r\n" + "Versione 1.0 \r\n" + "Copyright (c) Pietro Venanzangeli\r\n" );
      return true;
    }
    else if (crCommand.equalsIgnoreCase("HELP")) {
      String PrivateCommand = ""; /* mostra solo la lista dei comandi disponibili per ogni utente in base alle restrinzioni sull' accesso */
      for (Enumeration e = (crUser.GetCommand()).elements(); e.hasMoreElements();) {
        PrivateCommand += " " + e.nextElement();
      } 
      PrivateCommand = PrivateCommand.toUpperCase();
      OutBuff.print(" I comandi standard disponibili sono :\r\n USERINFO HELP ABOUT EXIT QUIT BYE\r\n");
      OutBuff.print(" I comandi di sistema a cui puoi accedere sono : \r\n" + PrivateCommand +"\r\n");
      return true;
    }
    else if (crCommand.equalsIgnoreCase("USERINFO")) {
      OutBuff.println(" USER [ " + crUser.GetUserID() +" ] \r\n IP [ " + crUser.GetIpAddress() + " ] "); // visualizza tutti i dati dell' user
      return true;
    }
    if (UsePersonalCommand) {
      /* comnadi personali */
      crCommand =Filter((String)(crUser.GetCommand()).get(crCommand));
    /* classe dinamica */
    try {
    Class DynaClass = Class.forName(crCommand);
    DynaMode ObjClass = (DynaMode)DynaClass.newInstance();
    ObjClass.Init();
    ObjClass.PExecute(crUser,"");
    return true;
    }
    catch(IllegalArgumentException e) {
    }
    catch(IllegalAccessException e) {
    }
    catch(ClassNotFoundException e) {
    }
    catch(InstantiationException e) {
    }
    }
    OutBuff.print(" Comando sconosciuto\r\n");
    System.out.println(" USER [ " + crUser.GetUserID() +" - " + crUser.GetIpAddress() + " ] Comando : " + Command + " non eseguito"); // visualizza tutti i comandi richiesti...
    
    return true;
  }



  /* 
   * filtra i comandi presi da input
   * @param stringa da filtrare
   * @return stringa filtrata.
   */
  private String Filter(String Command) {
    System.gc(); /* garbage collector */
    if (Command == null)return " "; /* per evitare che vada in errore torna sempre un valore */
      if (Command.compareTo("") != 0) {
      Command = Command.trim();
      Command = Command.toUpperCase();
      return Command;
    }
    return " ";
  }

}






