/*
 * Copyright (c) 1997 Pietro Venanzangeli - All Rights Reserved.
 */

/**
 * Realizza un piccolo server interrogabile tramite la porta 23.
 * @author  Pietro Venanzangeli.
 * @version 1.0, 14-Nov-1997
 */

import java.io.*;
import java.util.Vector;
import TException;
public class GetTelnetLine {
  /** Contiene la stringa di input */
  protected String Line = null;
  /** Buffer di input */
  protected BufferedReader InBuff;
  /** Buffer di output */
  protected PrintStream    OutBuff;

  /**
   * Costruttore
   * @param InBuff e' il Buffer di input
   * @param OutBuff e' il Buffer di output.
   */
  public GetTelnetLine(BufferedReader InBuff,PrintStream OutBuff) {
    this.InBuff  = InBuff;
    this.OutBuff = OutBuff;
    Line = new String("");
  }

  /**
   * Prende una linea dal telnet con echo sul telnet
   * @exception TException viene genarata se il client disconnette o chiude
   * @return stringa di input
   */

  public String GetLine() throws TException {
    char NewChar;
    /* toglie tutti i possibili elementi inseriti */
    Line = "";
    try {
      do {
        NewChar =(char)InBuff.read();
        if ((int)NewChar == 65535) { // disconnesione del computer remoto...
          throw new TException(" Telnet Disconnect");
        }
        if (NewChar == 0x08 ) { // back space 
          OutBuff.print((char)0x08);
          OutBuff.print(" ");
          OutBuff.print((char)0x08);
          if (Line. length()>0) { // toglie i caratteri nel buffer 
            Line = Line.substring(0,Line.length()-1);
          }
        }
        else {
          OutBuff.print(NewChar);
          Line = Line + NewChar;
        }
      }
      while (NewChar!='\n');
    }
    catch (IOException e) {
      String str = e.getMessage();
      if (str.compareTo("Connection reset by peer")==0) {
        throw new TException(" Telnet Close");
      }
      return null;
    }
    return Line.substring(0,Line.length()-2);
  }


  /**
   * Prende una linea dal telnet senza emette echo
   * @exception TException viene genarata se il client disconnette o chiude
   * @return stringa di input
   */
  public String GetNoEchoLine() throws TException{
    char NewChar;
    /** toglie tutti i possibili elementi inseriti */
    Line = "";
    try {
      do {
        NewChar=(char)InBuff.read();
        Line = Line + NewChar; 

      }
      while (NewChar!='\n');
    }
    catch (IOException e) {
      String str = e.getMessage();
      if (str.compareTo("Connection reset by peer")==0) {
        throw new TException(" Telnet Close");
      }
      return null;
    }
    return Line.substring(0,Line.length()-2);
  }
}




