/*
 * Copyright (c) 1997 Pietro Venanzangeli - All Rights Reserved.
 */

/**
 * Gestisce la certificazione di un nuovo utente.
 * @author  Pietro Venanzangeli.
 * @version 1.0, 14-Nov-1997
 */



import GetTelnetLine;
import java.io.*;
import java.util.Hashtable;
import User;
class LogIn {
  /** Contiene il Login */
  protected String Login      = "";
  /** Contiene la password */
  protected String Password   = ""; 
  /** contiene il numero di tentativi per utente */
  protected int UserRepeat    = 0;
  /** contiene il numero massimo di tentativi per utente */
  protected int MaxUserRepeat = 3; 
  /** contiene la stringa dei comandi dell' utente caricati dal file relativo */
  protected  Hashtable UserCommand;
  /** struttura dati inerente all' utente */
  protected User crUser;  

  /**
   * Costruttore di logIn
   * @param User e' la classe che contiene tutte le informazioni dell' utente.
   */
  public LogIn(User crUser) {
    this.crUser = crUser;
    GetTelnetLine tlLine = new GetTelnetLine(crUser.GetInBuff(),crUser.GetOutBuff());
    try {
      do {
        UserRepeat++;
        (crUser.GetOutBuff()).print("\r\nLogin    : ");
        Login    = tlLine.GetLine();
        if (Login == null)(crUser.GetOutBuff()).print("\r\n");
        (crUser.GetOutBuff()).print("Password : ");
        Password = tlLine.GetNoEchoLine();
      }
      while (ControlUser()==false  && UserRepeat < MaxUserRepeat);
    }
    catch (TException e ) {
    }
  }

  /** 
   * Controlla che l' utente appartiene a questo server.
   */

  private boolean ControlUser() {
    String Pass; /* contiene la password presa dal disco */
    if (Login == null || Password == null )return false;
    try {
      File inputFile = new File(Login+ ".psw");
      System.out.println(" Richieta di password per l' utente " + Login);
      BufferedReader fin = new BufferedReader(new InputStreamReader(new FileInputStream(inputFile)));
      Pass = fin.readLine();
      if (Pass.compareTo(Password) == 0) {/* verifica password utente */
        crUser.SetUserID(Login); /* setta l' userID per l' utente */
        crUser.SetPrivateDir(fin.readLine()); /* setta la directory privata */
        LoadUserCommand(fin);
        fin.close();
        return true;
      }
    }
    catch (FileNotFoundException e ) {
      System.out.println(" Utente " + Login + " non appartiene a questo Server. \r\n");
      return false;
    }
    catch (IOException e ) {
      return false;
    }
    return false;
  }
  /**
   * Carica tutti i comandi disponibili per l' utente
   * @param BufferedReader contiene il comando da inserire
   */
  private void LoadUserCommand(BufferedReader Fin) {
    int cont = -1;
    UserCommand = new Hashtable();
    String CtrlCommand = ""; /* contine il comando letto; */
    try {
      do {
        CtrlCommand = Fin.readLine();
        CtrlCommand = CtrlCommand.trim();
        CtrlCommand = CtrlCommand.toUpperCase();
        UserCommand.put(CtrlCommand,CtrlCommand);
        cont++;
      }
      while (CtrlCommand.compareTo("") != 0); 
    }
    catch (IOException e) {}
    System.out.println(" Caricati " + cont + " comandi per l'utente [ "+ Login + " - " + crUser.GetIpAddress() + " ]");
    crUser.SetCommand(UserCommand); /* immette la stringa dei comandi */
  }

}   



