/*
 * Copyright (c) 1997 Pietro Venanzangeli - All Rights Reserved.
 */

/**
 * Contiene tutti i dati di un nuovo utente.
 * @author  Pietro Venanzangeli.
 * @version 1.0, 14-Nov-1997
 */

import java.util.*;
import java.io.*;
import java.net.*;

public class User {
  /** UserID utente */
  protected String UserID;
  /** Ip utente */
  protected InetAddress IPAddress;
  /** directory privata */
  protected String PrivateDir;
  /** lista dei comandi */
  protected Hashtable Command;
  /** Buffer id Input */
  protected BufferedReader InBuff;
  /** Buffer di Output */
  protected PrintStream OutBuff;

  public User(String UserID, InetAddress IPAddress, String PrivateDir, Hashtable Command, BufferedReader InBuff, PrintStream OutBuff) {
    this.UserID     = UserID;
    this.IPAddress  = IPAddress;
    this.PrivateDir = PrivateDir;
    this.Command    = Command;
    this.InBuff   = InBuff;
    this.OutBuff    = OutBuff;
  }

  public User() {
  }

  /* 
   * Setta il valore dell' UserID
   * @param UserID e' l' UserID dell'utente
   */
  public void SetUserID(String UserID) {
    this.UserID = UserID;
  }

  /* 
   * Ritorna il valore dell' UserID
   * @return UserID.
   */
  public String GetUserID() {
    return UserID;
  }

  /* 
   * Setta il valore dell' IpAddress
   * @param IpAddress.
   */
  public void SetIpAddress(InetAddress IPAddress) {
    this.IPAddress = IPAddress;
  }

  /* 
   * Ritorna il valore dell' IpAddress
   * @return IpAddress.
   */
  public String GetIpAddress() {
   
      return (String)IPAddress.getHostName();
   
  }

  /* 
   * Setta il valore dell' PrivateDir
   * @param PrivateDir.
   */
  public void SetPrivateDir(String PrivateDir) {
    this.PrivateDir = PrivateDir;
  }
  /* 
   * ritorna il valore dell' PrivateDir
   * @return PrivateDir.
   */
  public String GetPrivateDir() {
    return PrivateDir;
  }
  /* 
   * Setta il valore del Command
   * @param Command e' la lista dei comandi presi dal file di configurazione.
   */
  public void SetCommand(Hashtable Command) {
    this. Command= Command;
  }
  /* 
   * Ritorna il valore di Command
   * @return Command.
   */
  public Hashtable GetCommand() {
    return Command;
  }
  /* 
   * Imposta il buffer di input 
   * @param InBuff.
   */
  public void SetInBuff(BufferedReader InBuff) {
    this.InBuff = InBuff;
  }
  /* 
   * ritorna l' impostazione del buffer di input
   * @return Input Buffer.
   */
  public BufferedReader GetInBuff() {
    return InBuff;
  }

  /* 
   * Imposta il buffer di output
   * @param OutBuff.
   */
  public void SetOutBuff(PrintStream OutBuff) {
    this.OutBuff = OutBuff;
  }
  /* 
   * Ritorna l' impostazione del buffer di output 
   * @return Output Buffer.
   */
  public PrintStream GetOutBuff() {
    return OutBuff;
  }
}

